using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Tag;
namespace CMSMicroservice.Protobuf.Validator.Tag;

public class GetAllTagByFilterRequestValidator : AbstractValidator<GetAllTagByFilterRequest>
{
    public GetAllTagByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllTagByFilterRequest>.CreateWithOptions((GetAllTagByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
